diff -uwbBpr libfloat/softfloat/bits64/timesoftfloat.c SoftFloat-2a/softfloat/bits64/timesoftfloat.c
--- libfloat/softfloat/bits64/timesoftfloat.c	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/timesoftfloat.c	Mon Sep 20 11:47:03 1999
@@ -3,10 +3,17 @@
 ===============================================================================
 
 This C source file is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 2.
+Arithmetic Package, Release 2a.
 
-Written by John R. Hauser.  More information is available through the Web
-page `http://HTTP.CS.Berkeley.EDU/~jhauser/arithmetic/softfloat.html'.
+Written by John R. Hauser.  This work was made possible in part by the
+International Computer Science Institute, located at Suite 600, 1947 Center
+Street, Berkeley, California 94704.  Funding was partially provided by the
+National Science Foundation under grant MIP-9311980.  The original version
+of this code was written as part of a project to build a fixed-point vector
+processor in collaboration with the University of California at Berkeley,
+overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
+is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
+arithmetic/SoftFloat.html'.
 
 THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
 has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
@@ -16,7 +23,7 @@ AND ALL LOSSES, COSTS, OR OTHER PROBLEMS
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
@@ -24,30 +31,25 @@ this code that are retained.
 
 #include <stdlib.h>
 #include <stdarg.h>
-#include <time.h>
 #include <string.h>
 #include <stdio.h>
+#include <time.h>
 #include "milieu.h"
 #include "softfloat.h"
 
-char *fail_programName = "timesoftfloat";
-
-void writeFailureV( const char *message, va_list varArgs )
-{
-
-    fprintf( stderr, "%s: ", fail_programName );
-    vfprintf( stderr, message, varArgs );
-    fputs( ".\n", stderr );
-
-}
+enum {
+    minIterations = 1000
+};
 
-void fail( const char *message, ... )
+static void fail( const char *message, ... )
 {
     va_list varArgs;
 
+    fputs( "timesoftfloat: ", stderr );
     va_start( varArgs, message );
-    writeFailureV( message, varArgs );
+    vfprintf( stderr, message, varArgs );
     va_end( varArgs );
+    fputs( ".\n", stderr );
     exit( EXIT_FAILURE );
 
 }
@@ -105,15 +107,16 @@ static void time_a_int32_z_float32( floa
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_int32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_int32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
     }
     endClock = clock();
@@ -131,15 +134,16 @@ static void time_a_int32_z_float64( floa
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_int32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_int32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
     }
     endClock = clock();
@@ -159,15 +163,16 @@ static void time_a_int32_z_floatx80( flo
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_int32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_int32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
     }
     endClock = clock();
@@ -189,15 +194,16 @@ static void time_a_int32_z_float128( flo
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_int32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_int32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
     }
     endClock = clock();
@@ -208,6 +214,161 @@ static void time_a_int32_z_float128( flo
 #endif
 
 enum {
+    numInputs_int64 = 32
+};
+
+static const int64 inputs_int64[ numInputs_int64 ] = {
+    LIT64( 0xFBFFC3FFFFFFFFFF ),
+    LIT64( 0x0000000003C589BC ),
+    LIT64( 0x00000000400013FE ),
+    LIT64( 0x0000000000186171 ),
+    LIT64( 0xFFFFFFFFFFFEFBFA ),
+    LIT64( 0xFFFFFD79E6DFFC73 ),
+    LIT64( 0x0000000010001DFF ),
+    LIT64( 0xDD1A0F0C78513710 ),
+    LIT64( 0xFFFF83FFFFFEFFFE ),
+    LIT64( 0x00756EBD1AD0C1C7 ),
+    LIT64( 0x0003FDFFFFFFFFBE ),
+    LIT64( 0x0007D0FB2C2CA951 ),
+    LIT64( 0x0007FC0007FFFFFE ),
+    LIT64( 0x0000001F942B18BB ),
+    LIT64( 0x0000080101FFFFFE ),
+    LIT64( 0xFFFFFFFFFFFF0978 ),
+    LIT64( 0x000000000008BFFF ),
+    LIT64( 0x0000000006F5AF08 ),
+    LIT64( 0xFFDEFF7FFFFFFFFE ),
+    LIT64( 0x0000000000000003 ),
+    LIT64( 0x3FFFFFFFFF80007D ),
+    LIT64( 0x0000000000000078 ),
+    LIT64( 0xFFF80000007FDFFD ),
+    LIT64( 0x1BBC775B78016AB0 ),
+    LIT64( 0xFFF9001FFFFFFFFE ),
+    LIT64( 0xFFFD4767AB98E43F ),
+    LIT64( 0xFFFFFEFFFE00001E ),
+    LIT64( 0xFFFFFFFFFFF04EFD ),
+    LIT64( 0x07FFFFFFFFFFF7FF ),
+    LIT64( 0xFFFC9EAA38F89050 ),
+    LIT64( 0x00000020FBFFFFFE ),
+    LIT64( 0x0000099AE6455357 )
+};
+
+static void time_a_int64_z_float32( float32 function( int64 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            function( inputs_int64[ inputNum ] );
+            inputNum = ( inputNum + 1 ) & ( numInputs_int64 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        function( inputs_int64[ inputNum ] );
+        inputNum = ( inputNum + 1 ) & ( numInputs_int64 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
+static void time_a_int64_z_float64( float64 function( int64 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            function( inputs_int64[ inputNum ] );
+            inputNum = ( inputNum + 1 ) & ( numInputs_int64 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        function( inputs_int64[ inputNum ] );
+        inputNum = ( inputNum + 1 ) & ( numInputs_int64 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
+#ifdef FLOATX80
+
+static void time_a_int64_z_floatx80( floatx80 function( int64 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            function( inputs_int64[ inputNum ] );
+            inputNum = ( inputNum + 1 ) & ( numInputs_int64 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        function( inputs_int64[ inputNum ] );
+        inputNum = ( inputNum + 1 ) & ( numInputs_int64 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
+#endif
+
+#ifdef FLOAT128
+
+static void time_a_int64_z_float128( float128 function( int64 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            function( inputs_int64[ inputNum ] );
+            inputNum = ( inputNum + 1 ) & ( numInputs_int64 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        function( inputs_int64[ inputNum ] );
+        inputNum = ( inputNum + 1 ) & ( numInputs_int64 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
+#endif
+
+enum {
     numInputs_float32 = 32
 };
 
@@ -232,15 +393,43 @@ static void time_a_float32_z_int32( int3
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32[ inputNum ] );
+            inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        function( inputs_float32[ inputNum ] );
+        inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
+static void time_a_float32_z_int64( int64 function( float32 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
     }
     endClock = clock();
@@ -258,15 +447,16 @@ static void time_a_float32_z_float64( fl
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
     }
     endClock = clock();
@@ -286,15 +476,16 @@ static void time_a_float32_z_floatx80( f
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
     }
     endClock = clock();
@@ -316,15 +507,16 @@ static void time_a_float32_z_float128( f
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
     }
     endClock = clock();
@@ -344,15 +536,16 @@ static void time_az_float32( float32 fun
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
     }
     endClock = clock();
@@ -371,20 +564,19 @@ static void time_ab_float32_z_flag( flag
     inputNumB = 0;
     startClock = clock();
     do {
-        (void)
+        for ( i = minIterations; i; --i ) {
             function(
                 inputs_float32[ inputNumA ], inputs_float32[ inputNumB ] );
-        ++count;
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float32 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void)
+    for ( i = count; i; --i ) {
             function(
                 inputs_float32[ inputNumA ], inputs_float32[ inputNumB ] );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float32 - 1 );
@@ -407,20 +599,19 @@ static void time_abz_float32( float32 fu
     inputNumB = 0;
     startClock = clock();
     do {
-        (void)
+        for ( i = minIterations; i; --i ) {
             function(
                 inputs_float32[ inputNumA ], inputs_float32[ inputNumB ] );
-        ++count;
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float32 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void)
+    for ( i = count; i; --i ) {
             function(
                 inputs_float32[ inputNumA ], inputs_float32[ inputNumB ] );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float32 - 1 );
@@ -432,6 +623,44 @@ static void time_abz_float32( float32 fu
 
 }
 
+static const float32 inputs_float32_pos[ numInputs_float32 ] = {
+    0x4EFA0000, 0x41D0B328, 0x00000000, 0x3E69A31E,
+    0x2F803EFF, 0x3F800000, 0x17BF8000, 0x674A301A,
+    0x4E010003, 0x7EE3C75D, 0x3D803FE0, 0x3FFEFF00,
+    0x7981F800, 0x431FFFFC, 0x4100C000, 0x3D87EFFF,
+    0x4103FEFE, 0x3C000007, 0x3F01F7FF, 0x4E6C6B5C,
+    0x4187FFFE, 0x458B9F13, 0x4F88007F, 0x5F004007,
+    0x37FFD7FE, 0x7E8001FB, 0x46EFFBFF, 0x31C10000,
+    0x5B428661, 0x33F89B1F, 0x23BFEFFF, 0x537BFFBE
+};
+
+static void time_az_float32_pos( float32 function( float32 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32_pos[ inputNum ] );
+            inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        function( inputs_float32_pos[ inputNum ] );
+        inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
 enum {
     numInputs_float64 = 32
 };
@@ -481,15 +710,16 @@ static void time_a_float64_z_int32( int3
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float64[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float64[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float64[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float64[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
     }
     endClock = clock();
@@ -497,6 +727,32 @@ static void time_a_float64_z_int32( int3
 
 }
 
+static void time_a_float64_z_int64( int64 function( float64 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float64[ inputNum ] );
+            inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        function( inputs_float64[ inputNum ] );
+        inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
 
 static void time_a_float64_z_float32( float32 function( float64 ) )
 {
@@ -508,15 +764,16 @@ static void time_a_float64_z_float32( fl
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float64[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float64[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float64[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float64[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
     }
     endClock = clock();
@@ -536,15 +793,16 @@ static void time_a_float64_z_floatx80( f
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float64[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float64[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float64[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float64[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
     }
     endClock = clock();
@@ -566,15 +824,16 @@ static void time_a_float64_z_float128( f
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float64[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float64[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float64[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float64[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
     }
     endClock = clock();
@@ -594,15 +853,16 @@ static void time_az_float64( float64 fun
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float64[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float64[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float64[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float64[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
     }
     endClock = clock();
@@ -621,20 +881,19 @@ static void time_ab_float64_z_flag( flag
     inputNumB = 0;
     startClock = clock();
     do {
-        (void)
+        for ( i = minIterations; i; --i ) {
             function(
                 inputs_float64[ inputNumA ], inputs_float64[ inputNumB ] );
-        ++count;
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float64 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void)
+    for ( i = count; i; --i ) {
             function(
                 inputs_float64[ inputNumA ], inputs_float64[ inputNumB ] );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float64 - 1 );
@@ -657,20 +916,19 @@ static void time_abz_float64( float64 fu
     inputNumB = 0;
     startClock = clock();
     do {
-        (void)
+        for ( i = minIterations; i; --i ) {
             function(
                 inputs_float64[ inputNumA ], inputs_float64[ inputNumB ] );
-        ++count;
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float64 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void)
+    for ( i = count; i; --i ) {
             function(
                 inputs_float64[ inputNumA ], inputs_float64[ inputNumB ] );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float64 - 1 );
@@ -682,6 +940,68 @@ static void time_abz_float64( float64 fu
 
 }
 
+static const float64 inputs_float64_pos[ numInputs_float64 ] = {
+    LIT64( 0x422FFFC008000000 ),
+    LIT64( 0x37E0000480000000 ),
+    LIT64( 0x73FD2546120B7935 ),
+    LIT64( 0x3FF0000000000000 ),
+    LIT64( 0x4E07F766F09588D6 ),
+    LIT64( 0x0000000000000000 ),
+    LIT64( 0x3FCE000400000000 ),
+    LIT64( 0x0313B60F0032BED8 ),
+    LIT64( 0x41EFFFFFC0002000 ),
+    LIT64( 0x3FB3C75D224F2B0F ),
+    LIT64( 0x7FD00000004000FF ),
+    LIT64( 0x212FFF8000001FFF ),
+    LIT64( 0x3EE0000000FE0000 ),
+    LIT64( 0x0010000080000004 ),
+    LIT64( 0x41CFFFFE00000020 ),
+    LIT64( 0x40303FFFFFFFFFFD ),
+    LIT64( 0x3FD000003FEFFFFF ),
+    LIT64( 0x3FD0000010000000 ),
+    LIT64( 0x37FC6B5C16CA55CF ),
+    LIT64( 0x413EEB940B9D1301 ),
+    LIT64( 0x47E00200001FFFFF ),
+    LIT64( 0x47F00021FFFFFFFE ),
+    LIT64( 0x3FFFFFFFF80000FF ),
+    LIT64( 0x407FFFFFE00FFFFF ),
+    LIT64( 0x001497A63740C5E8 ),
+    LIT64( 0x44BFFFE0001FFFFF ),
+    LIT64( 0x16FFDFFEFFFFFFFF ),
+    LIT64( 0x403FC000000001FE ),
+    LIT64( 0x7FD00000000001F6 ),
+    LIT64( 0x0640400002000000 ),
+    LIT64( 0x479CEE1E4F789FE0 ),
+    LIT64( 0x4237FFFFFFFFFDFE )
+};
+
+static void time_az_float64_pos( float64 function( float64 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float64_pos[ inputNum ] );
+            inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        function( inputs_float64_pos[ inputNum ] );
+        inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
 #ifdef FLOATX80
 
 enum {
@@ -737,19 +1057,52 @@ static void time_a_floatx80_z_int32( int
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
+            a.low = inputs_floatx80[ inputNum ].low;
+            a.high = inputs_floatx80[ inputNum ].high;
+            function( a );
+            inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        a.low = inputs_floatx80[ inputNum ].low;
+        a.high = inputs_floatx80[ inputNum ].high;
+        function( a );
+        inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
+static void time_a_floatx80_z_int64( int64 function( floatx80 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+    floatx80 a;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_floatx80[ inputNum ].low;
         a.high = inputs_floatx80[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_floatx80[ inputNum ].low;
         a.high = inputs_floatx80[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
     }
     endClock = clock();
@@ -768,19 +1121,20 @@ static void time_a_floatx80_z_float32( f
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_floatx80[ inputNum ].low;
         a.high = inputs_floatx80[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_floatx80[ inputNum ].low;
         a.high = inputs_floatx80[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
     }
     endClock = clock();
@@ -799,19 +1153,20 @@ static void time_a_floatx80_z_float64( f
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_floatx80[ inputNum ].low;
         a.high = inputs_floatx80[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_floatx80[ inputNum ].low;
         a.high = inputs_floatx80[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
     }
     endClock = clock();
@@ -832,19 +1187,20 @@ static void time_a_floatx80_z_float128( 
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_floatx80[ inputNum ].low;
         a.high = inputs_floatx80[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_floatx80[ inputNum ].low;
         a.high = inputs_floatx80[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_floatx80 - 1 );
     }
     endClock = clock();
